@ECHO OFF
SETLOCAL EnableDelayedExpansion

TITLE FFmpeg ѹƽű

FOR %%P IN ("ffmpeg.exe" "ffprobe.exe" "qaac64.exe") DO IF NOT EXIST "%~dp0bin\%%~P" (
    CLS
    ECHO  bin Ŀ¼Ҳ %%~P
    GOTO :error
)
IF EXIST "%~dp0\encoding.cfg" FOR /F "eol=; delims=" %%C IN ('TYPE "%~dp0\encoding.cfg"') DO SET "%%C"
SET FFPROBECMD="%~dp0bin\ffprobe.exe" -show_entries stream=index^,codec_name^,bit_rate -select_streams a -of compact=p=0:nk=1 -loglevel error

:nextarg
IF NOT EXIST "%~1" (
    CLS
    ECHO Ҳļ %~1
    GOTO :error
)
IF "%~x1"==".ass" SET "SUB=%~1" & GOTO :shift
IF "%~x1"==".cfg" ( FOR /F "eol=; delims=" %%C IN ('TYPE "%~1"') DO SET "%%C" ) & GOTO :shift
FOR %%X IN (".m4a" ".wav" ".mp3") DO IF "%~x1"=="%%~X" SET "AIN=%~1" & GOTO :shift
IF "!VIN!"=="" (
    SET "VIN=%~1"
    SET "VDIR=%~dp1"
    SET "VNAME=%~n1"
    SET "VBASE=!VDIR!!VNAME!"
) ELSE SET "VIN_A=%~1" & GOTO :shift

:shift
SHIFT /1
IF NOT "%~1"=="" GOTO :nextarg

IF "%VIN%"=="" (
    CLS
    ECHO ҲƵļ
    GOTO :error
)

IF "%AIN%"=="" (
    IF "%VIN_A%"=="" SET "VIN_A=%VIN%"
    SET "AIN=!VIN_A!"
)

:ffprobe
FOR /F "tokens=1,2,3 delims=|" %%E IN ('"%FFPROBECMD% "%AIN%""') DO (
    IF "!AENC!"=="" SET "ADEC=%%F" & SET "ASTREAM=%%E" & SET "AENC=qaac"
    IF NOT "!AENC!"=="copy" IF "%%F"=="aac" IF %%G LEQ 192000 (
        SET "ADEC=%%F" & SET "ASTREAM=%%E" & SET "AENC=copy"
    )
)

IF "%ADEC%"=="" (
    IF "!AIN!"=="!VIN_A!" IF NOT "!VIN_A!"=="!VIN!" (
        SET "AIN=%VIN%" & SET "VIN=%VIN_A%"
        GOTO :ffprobe
    )
    CLS
    ECHO ûṩƵƵԴƵļ
    GOTO :error
)

IF "%AENC%"=="copy" (
    SET "AINPUTCMD="%~dp0bin\ffmpeg" -y %IARGS% -i "%VIN%" -i "%AIN%" -map 0:v -map 1:%ASTREAM% %OARGS%"
) ELSE (
    SET "AINPUTCMD="%~dp0bin\ffmpeg" %IARGS% -i "%AIN%" -map 0:%ASTREAM% %OARGS% -vn -sn -c:a pcm_s16le -f wav - | "%~dp0bin\qaac64" -q 2 --ignorelength -c 192 - --adts -o - | "%~dp0bin\ffmpeg" -y %IARGS% -i "%VIN%" -i - -bsf:a aac_adtstoasc -map 0:v -map 1:0 %OARGS%"
)

FOR %%V IN (FPS IARGS OARGS VENCARGS VOUT) DO CALL SET "%%V=!%%V!"
IF "%VOUT%"=="" IF NOT "%SUB%"=="" ( SET "VOUT=%VBASE%_subbed.mp4" ) ELSE ( SET "VOUT=%VBASE%_muxed.mp4" )
IF "%FPS%"=="" SET FPS=30

IF "%VENCARGS_X264%"=="" ( SET VENCARGS_X264=-preset fast -crf 20 ) ELSE ( ECHO  x264 Ԥ裺%VENCARGS_X264% )
IF "%VENCARGS_QSV%"=="" ( SET VENCARGS_QSV=-c:v h264_qsv -global_quality 19 ) ELSE ( ECHO  QSV Ԥ裺%VENCARGS_X264% )
IF "%VENCARGS_NVENC%"=="" ( SET VENCARGS_NVENC=-c:v h264_nvenc -rc vbr_hq -cq 19 -profile high ) ELSE ( ECHO  NVENC Ԥ裺%VENCARGS_X264% )

FOR %%X IN ("1|X264|x264" "2|QSV|Intel QSV" "3|NVENC|NVENC") DO (
    FOR /F "tokens=1,2,3 delims=|" %%P IN (%%X) DO SET "ENCSNAME[%%P]=%%Q" & SET "ENCLNAME[%%P]=%%R"
)

ECHO ԴƵļ%VIN%
ECHO ԴƵļ%AIN% (%ASTREAM%: %ADEC% -^> %AENC%)
IF NOT "%SUB%"=="" ECHO Ļļ%SUB% (libass)
IF NOT "%VENCARGS%"=="" (
    ECHO Զ%VENCARGS%
) ELSE IF NOT "%VENCPRESET%"=="" (
    ECHO Ԥ裺%VENCPRESET% ^(!ENCLNAME[%VENCPRESET%]!^)
)
IF NOT "%IARGS%"=="" ECHO %IARGS%
IF NOT "%OARGS%"=="" ECHO %OARGS%
ECHO Ŀ֡ʣ%FPS% fps
ECHO ĿƵļ%VOUT%
ECHO ȷϢȷ밴 Ctrl-C ֹű
PAUSE

IF NOT "%SUB%"=="" SET SUBOPTS=^,ass=~tmp.ass
IF NOT "%VENCARGS%"=="" GOTO :job

IF NOT "%VENCPRESET%"=="" GOTO :parse
ECHO Ƶ1. x264Ĭϣ 2. Intel QSV3. NVENC
SET /P VENCPRESET="ΪĬֵ 1" 

IF "%VENCPRESET%"=="" GOTO :default

:parse
SET "OTHERS=" & FOR /F "delims=123" %%I IN ("%VENCPRESET%") DO SET "OTHERS=%%I"
IF DEFINED OTHERS GOTO :illegal
CALL SET "VENCARGS=%%VENCARGS_!ENCSNAME[%VENCPRESET%]!%%"
GOTO :job

:illegal
ECHO ʹĬֵ

:default
SET "VENCARGS=%VENCARGS_X264%"

:job
SET "VENCARGS=%VENCARGS% -keyint_min "%FPS%" -g "%FPS%*10.01" -movflags faststart"
IF NOT "%SUB%"=="" COPY /Y "%SUB%" "~tmp.ass"
ECHO ON
%AINPUTCMD% -vf fps=fps=%FPS%,format=yuv420p%SUBOPTS% -c:a copy %VENCARGS% "%VOUT%"

@ECHO OFF
IF NOT "%SUB%"=="" DEL "~tmp.ass"
ECHO.
PAUSE
GOTO :EOF

:error
ECHO.
TITLE [] FFmpeg ѹƽű
PAUSE
GOTO :EOF
